<?php
 include_once(dirname(__FILE__).'/shm.php');
 global $descr,$debug,$config,$grurl,$memorize_debug,$memorize_details;
 $descr=build_aditional_descriptor();
 
/*******************************************************************************

    Author ......... johnrembo
    Contact ........ johnrembo@cacti-forums
    Home Site ...... http://forums.cacti.net/
    Program ........ memorize
    Version ........ 0.2
    Purpose ........ memorize plugin for cacti

*******************************************************************************/

function plugin_init_memorize() {
    global $plugin_hooks;
    $plugin_hooks['config_arrays']['memorize'] = 'memorize_config_arrays';
    $plugin_hooks['config_settings']['memorize'] = 'memorize_config_settings';
    $plugin_hooks['rrdtool_function_graph_cache_check']['memorize'] = 'memorize_graph_cache_check';	//is graph cached allready?
    $plugin_hooks['prep_graph_array']['memorize'] = 'memorize_graph_set_options';			//divert output to memorize
    $plugin_hooks['rrdtool_function_graph_set_file']['memorize'] = 'memorize_catch_output';		//display output and save in shared mem
    $plugin_hooks['poller_top']['memorize'] = 'memorize_clean_old_data';				//clean expired cache
}

function memorize_version () {
    return array(
	    'name' => 'memorize',
    	    'version' => '0.2',
            'longname' => 'memorize plugin for cacti',
            'author' => 'johnrembo',
            'homepage' => 'http;//forums.cacti.net',
            'email' => 'johnrembo@cacti-forums',
            'url' => 'http://forums.cacti.net/viewtopic.php?t=28384'
            );
}

function memorize_config_arrays () {
    $realm_id=101;
    global $user_auth_realms, $user_auth_realm_filenames;
    $user_auth_realms[$realm_id]='Memorize';
    $user_auth_realm_filenames['memorize.php'] = $realm_id;
}

function memorize_config_settings () {
    global $config,$tabs,$settings;
    
    $tabs['memorize'] = 'Memorize';
    
    $tb=stat_table_exists();
    if (!$tb && PHP_OS!='WINNT')
	init_memorize_table();
    
    requirements();
    
    $temp = array(
        "memorize_flush" => array(
            "friendly_name" => "<table width=100%><tr><td><strong>Flush Cache</strong><br>Remove all currently cached images from shared memory <strong><a style='cursor:pointer' title='this happens on every pooling cycle'>!</a></strong><td></td><td valign=middle align=right><input type=button value='Flush' onclick=\"window.open('".$config['url_path']."plugins/memorize/memorize.php?action=flush','Memorize','width=325,height=200,menubar=no,toolbar=no,location=no,resizable=yes')\"></td></tr></table>",
            "method" => "spacer",
            ),
        "memorize_stats" => array(
            "friendly_name" => "<table width=100%><tr><td><strong>Show Statistics</strong><br>Display Cache Statistics<td></td><td valign=middle align=right><input type=button value='Show' onclick=\"window.open('".$config['url_path']."plugins/memorize/memorize.php?action=showstats','Memorize','width=325,height=200,menubar=no,toolbar=no,location=no,resizable=yes')\"></td></tr></table>",
            "method" => "spacer",
            ),
        "memorize_debug" => array(
            "friendly_name" => "debug",
            "description" => "enable/disable memorize debug messages in cacti-log",
            "method" => "drop_array",
            "default" => 0,
            "array" => array("off","on")
         ),
        "memorize_details" => array(
            "friendly_name" => "details on image",
            "description" => "show/hide statistical information on the right-bottom corner of the image <strong><a style='cursor:pointer' title='requires php-GD2 support'>!</a></strong>",
            "method" => "drop_array",
            "default" => 1,
            "array" => array("hide","show")
         ),
	);
        
    if (isset($settings["memorize"]))
        $settings["memorize"] = array_merge($settings["memorize"], $temp);
    else
        $settings["memorize"]=$temp;
}

function memorize_graph_cache_check($data) {
    global $config,$descr,$memorize_debug,$memorize_details;
    $memorize_debug=@read_config_option("memorize_debug");
    $memorize_details=@read_config_option("memorize_details");

    //do not cache graphs beign edited or zoomed
    if ( !(isset($_REQUEST['action']) && in_array($_REQUEST['action'],array('zoom','properties','edit'))) && PHP_OS!='WINNT' && requirements() ) {

	$lgi=$data['local_graph_id'];
	$rraid=$data['rra_id'];
	$ts = mct_f();//record timestamp
	$addr="$lgi$rraid$descr";//generate address for shm
	
	if ($memorize_debug) {
	    global $grurl;
	    $grurl="<strong><a target='_blank' href='${config['url_path']}graph_image.php?action=view&local_graph_id=$lgi&rra_id=$rraid'>$lgi</a></strong>";
	    cacti_log("MEMORIZE: requesting for local_graph_id=$grurl");
	}
	
	if (($lgi=$data['local_graph_id'])>0) {
            $cached=shm_operate($addr);
	} else  {
            $cached=false;
	}
	
	if ($cached) {
    	    $pi=read_config_option("poller_interval");
    	    if ( ($tdiff=time()-$cached['time'])<$pi ) {
		$te = mct_f(); $dt = round($te - $ts,6);//calculate image retrieval duration
		if ($memorize_debug) cacti_log("MEMORIZE: graph $grurl rendered from cache in <strong>$dt</strong> second(s)");
		save_stats($lgi,$rraid,$addr,$dt,1);

		if($memorize_details && ($img=add_memorize_legend($cached['data'],"rendered from cache in $dt second(s)"))==true) {//put some info on graph
        	    return array('return'=>$img);
		}else{
        	    return array('return'=>$cached['data']);//return original cached image
        	}
        	
    	    } else {//graph has expired
		shm_operate($addr,$cached,true); //clean expired image from cache
		shm_operate(hash_and_clean($addr,6),$ts); //save timestamp when image generation had started
		save_stats($lgi,$rraid,$addr,$dt,1,true);
		if ($memorize_debug) cacti_log("MEMORIZE: graph $grurl expired. removed from cache.");
    	    }
	} else {
	    shm_operate(hash_and_clean($addr,6),$ts);  //save timestamp when image generation had started
	    if ($memorize_debug) cacti_log("MEMORIZE: graph $grurl isn't cached yet.");
	}
    }
}

function memorize_graph_set_options($opt) {
     //do not cache graphs being edited or zoomed
    if ( !(isset($_REQUEST['action']) && in_array($_REQUEST['action'],array('zoom','properties','edit'))) && PHP_OS!='WINNT' && requirements() && !(isset($opt['output_flag']) && $opt['output_flag']==RRDTOOL_OUTPUT_STDERR) )
	$opt['output_flag']=RRDTOOL_OUTPUT_STDOUT;

    return $opt;
}

function memorize_catch_output($data) {
    global $descr,$grurl,$memorize_debug,$memorize_details;
    
    if(!requirements())
	return false;

    $image=$data['output'];
    
    if (strlen($image)>100) {//some insurance
	$lgi=$data['local_graph_id'];
	$rraid=$data['rra_id'];
	$addr="$lgi$rraid$descr";
	
	$time_cell_addr=hash_and_clean($addr,6);
	$ts=shm_operate($time_cell_addr); // catch timestamp when image generation had started
	$time='unknown number of';
	
	if ($ts) {//calculate graph rendering duration
	    $time = round((mct_f()-$ts),6);
	    shm_operate($time_cell_addr,$ts,true);
	}
	
	if (!shm_operate($addr,array('time'=>time(),'data'=>$image))) {//it's possible graph won't fit in shared-memory
	    if ($memorize_debug) cacti_log("MEMORIZE: unable to cache graph $grurl. graph rendered in $time seconds");
	} else {
	     save_stats($lgi,$rraid,$addr,$time,0);
	    if ($memorize_debug) cacti_log("MEMORIZE: graph $grurl rendered from rrd and cached in <strong>$time</strong> second(s)");
	}

	if($memorize_details && ($img=add_memorize_legend($image,"rendered from rrd in $time second(s)"))==true) {//show graph with statistical information
	    print $img;
	    return true;
	}else{
	    print $image;//show original graph
	    return true;
	}
    }
}

//clean cache with every pooling cycle
function memorize_clean_old_data($skip_poller_check=false) {
    if(!$skip_poller_check) {
	$pi=read_config_option("poller_interval");
	$diff=(date('i',time())*60)%$pi;//13min=3min
	$start=date('Y-m-d G:i:00',strtotime("-${diff} sec"));//13min - 3min=10min
	
	$sql="SELECT shm_addr FROM plugin_memorize_stats WHERE render_time<'$start' group by shm_addr";
    } else {
	$sql="SELECT shm_addr FROM plugin_memorize_stats group by shm_addr";
    }
    
    $outdated=db_fetch_assoc($sql);
    
    $tot=0;
    foreach ($outdated as $outd) {
	$i=shm_flush($outd['shm_addr']);//clean cached images
	$t=shm_flush(hash_and_clean($outd['shm_addr'].'stat',6));//clean cached timestamps
	if($i) $tot++;
	if($t) $tot++;
    }
    
    if(!$skip_poller_check)
	$sql="DELETE FROM plugin_memorize_stats WHERE render_time<'$start'";
    else
	$sql="DELETE FROM plugin_memorize_stats";
    
    db_execute($sql);
    
    cacti_log("MEMORIZE: removed $tot records from shared memory");
    
    return $tot;
}

//creates aditional indentifiers for thumbnails ,tresholded images etc...
function build_aditional_descriptor() {
    $r=$_REQUEST;
    $d1=(isset($r['graph_height']) && is_numeric($r['graph_height'])) ? $r['graph_height'] : '';
    $d2=(isset($r['graph_width']) && is_numeric($r['graph_width'])) ? $r['graph_width'] : '';
    $d3=(isset($r['graph_nolegend']) && is_bool($r['graph_nolegend'])) ? $r['graph_nolegend'] : '';
    $adescr=$d1.$d2.$d3;
    return hash_and_clean($adescr,4);
}

//change string to it's unique numeric representation
function hash_and_clean($str,$len=0) {
    $number=preg_replace('/[^\d+]|0/i','',md5($str));
    if ($len>0)
	return substr($number,0,$len);
    else
	return $number;
}

//record current microtime
function mct_f() {
    list($usec, $sec) = explode(" ", microtime());
    return ((float)$usec + (float)$sec);
}

//check if memorize sql table exists
function stat_table_exists() {
    $tb=db_fetch_cell("show tables like 'plugin_memorize_stats';");
    if(!$tb || $tb=='') return false;
    else return true;
}

//create memorize sql table
function init_memorize_table() {
	$result=db_execute("CREATE TABLE `plugin_memorize_stats` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `local_graph_id` mediumint(8) unsigned NOT NULL,
  `rra_id` tinyint(3) unsigned NOT NULL,
  `shm_addr` varchar(15) NOT NULL COMMENT 'shared memory address of the cached image',
  `render_time` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP COMMENT 'time when image was rendered',
  `render_duration` varchar(10) NOT NULL COMMENT 'duration in seconds how long image render took',
  `render_origin` tinyint(3) unsigned NOT NULL COMMENT '0=data-source, 1=cache',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='statistics for the memorize plugin';");
	if (!$result)
	    cacti_log("MEMORIZE: unable to create mysql table 'plugin_memorize_stats'");
	else 
	    cacti_log("MEMORIZE: <strong>'plugin_memorize_stats'</strong> table created");
}

//save information to sql database for memory-cleanup or statistical operations
function save_stats($lgi,$rraid,$addr,$duration,$origin,$update=false) {
    if(!is_numeric($duration)) $duration=0;
    if ($update) {
	$sql="DELETE FROM plugin_memorize_stats WHERE shm_addr=$addr;";
	shm_flush(hash_and_clean($addr.'stat',6));//clean fast statistics cache
    } else {
	$sql="INSERT INTO plugin_memorize_stats (local_graph_id,rra_id,shm_addr,render_time,render_duration,render_origin) values ($lgi,$rraid,$addr,NOW(),$duration,$origin);";
	shm_operate(hash_and_clean($addr.'stat',6),array($origin,$duration));//update fast statistics cache
    }
    db_execute($sql);
}

//convert string into transparent image
function txt2img($text) {
    $font = dirname(__FILE__).'/Vera.ttf';
    $fontsize = '7';

    // Create the image
    $size = imagettfbbox($fontsize, 0, $font, $text); // Set the positions of the area of the font
    $width = $size[2] + $size[0] + 1;
    $height = abs($size[1]) + abs($size[7]);
    $im = imagecreate($width, $height);
    
    $grey = imagecolorallocate($im, 240, 240, 240);
    $darkgrey = imagecolorallocate($im, 176, 176, 176);
    
    $colourDarkgrey = imagecolorallocate($im, 240, 240, 240);
    imagecolortransparent($im, $colourDarkgrey); // Make dark-grey colour transparent
    
    imagefttext($im, $fontsize, 0, 0, abs($size[5]), $darkgrey, $font, $text);
    
    return $im;
}

//write text-block to png image
function add_memorize_legend($image,$legend) {
    $newimg = imagecreatefromstring((string)$image);
    $watermark=txt2img($legend);

    imagealphablending($watermark, true);
    imagesavealpha($watermark, false);
    $watermark_width = imagesx($watermark);
    $watermark_height = imagesy($watermark);

    $dest_x = imagesx($newimg) - $watermark_width - 3;
    $dest_y = imagesy($newimg) - $watermark_height - 3 ;

    $status=imagecopy($newimg, $watermark, $dest_x, $dest_y, 0, 0, $watermark_width, $watermark_height);

    $img=NULL;
    ob_start();
	print imagepng($newimg,NULL,9);
	$img=ob_get_contents();
    ob_end_clean();

    imagedestroy($watermark);
    imagedestroy($newimg);
    
    return $img;
}

//plugin won't run without these requirement followed
function requirements() {
    $required=array(
	'GD2'=>'gd_info',
	'shmop,sysvshm'=>'shm_attach',
	'sysvsem'=>'sem_get'
    );
    foreach ($required as $ext=>$func) {
	$on=function_exists($func);
	if (!$on) {
	    $missing[]=$ext;
	}
    }
    if(isset($missing)) {
	cacti_log("MEMORIZE: plugin requires the following php extensions to be loaded: [".implode(',',$missing)."]");
	return false;
    } else {
	$gd=gd_info();
	if(stristr($gd['GD Version'],'1.'))
	    $missing[]='GD version 2(GD2)';
	if(!$gd['FreeType Support'])
	    $missing[]='FreeType library support for GD2';
	if(!$gd['PNG Support'])
	    $missing[]='PNG support for GD2';
	if(isset($missing)) {
	    cacti_log("MEMORIZE: plugin requires the following php GD extension features: [".implode(',',$missing)."]");
	    return false;
	}
    }
    return true;
}

?>